; Bootsector ok KOS
; version beta 0.02
; this version load a kernel (512 bytes) and execute it

[BITS 16]
[ORG 0x7C00]              ; the code start at the beginning of the file
			

jmp start               ; go to entry point

bootdrv 	db      0 ; needed to save bootdrive number
texte   	db 	'Loading KOS', 13, 10 ,0 ; define a text
check   	db 	'Checking for a 386+ processor...', 0
found386 	db 	' Found', 13, 10, 0
need386 	db 	' Not Found', 13, 10, 0

message:                ; procedure which print the string pointed by ds:si
			; to screen

	lodsb           ; load ds:si in al and make si++
	or al, al       ; if al = 0
	jz done         ; then done cause it's the end of the string
	mov ah, 0eh     ; use service 0eh
	mov bx, 0007    ; parameters
	int 0x10        ; call to interrupt 10
	jmp message     ; loop until the end of the string
done:
	ret             ; return in main code

no386:
	mov si, need386
	call message
	
	
reboot:
	jmp 0xF000:0xFFF0
	
start:                  ; entry point, the execution start here
	
	mov ax, 0       ; the code is at 0:0x7C00
	mov ds, ax      ; in the memory, in ax. And put it in ds
	mov [bootdrv], dl

	
	mov ax, 0x9000
	mov ss, ax
	mov sp, 0xff80
	

	mov si, texte   ; put the offset of the string in si
			; now texte is pointed by ds:si
	call message    ; call the procedure
	mov si, check
	call message

	; detect if the process if at least a 386 ! (needed for protected mode)
	pushf
	mov ah, 70h
	push ax
	popf
	pushf
	pop ax
	cmp ah, 70h
	jne no386
	
	mov si, found386
	call message

; now, we can put the system in protected mode. But there is a problem :
; i do not really know how to do it !!!!
; We must build Global Descriptor Table & Interrupt Descriptor Table
; and then set the Protected Mode bit in E-flags to 1
; that's all what i know for the moment
; so, i just want to make a test : loading a little kernel in the ram
; and then run it !! it could be fun !!!

; let's go

; first reset the disk controller

readme:
	xor ax, ax
	int 0x13
	jc reboot

; then load sector 2 at 0x9000:0

	mov ax, 0x09000
	mov es, ax
	xor bx, bx

	mov ax, 0x0202
	mov ch, 0
	mov cl, 2
	mov dh, 0
	mov dl, [bootdrv]
	int 0x13
	jc readme

; The kernel was linked in "tiny" model.  "tiny" is the 16-bit version
; of "flat" model.  These models assume that cs,ds,es and ss all have
; the same base.  We set ss to 0x9000 earlier.  Here we copy ss to
; both ds and es.	
	push ss
	pop  ds
	push ss
	pop  es

; and jump to it
	jmp 9000h:0

times 510-($-$$) db 144
dw 0xAA55

; this is the kernel !!!


